package es.uca.xmleye;

/*
 Copyright (C) 2008 Antonio García Domínguez

 This program is free software; you can redistribute it 
 and/or modify it under the terms of the GNU General Public 
 License as published by the Free Software Foundation; 
 either version 2 of the License, or (at your option) any 
 later version.

 This program is distributed in the hope that it will be 
 useful, but WITHOUT ANY WARRANTY; without even the implied 
 warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 PURPOSE. See the GNU General Public License for more 
 details.

 You should have received a copy of the GNU General Public 
 License along with this program; if not, write to the Free 
 Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA 02111-1307 USA
 */

import java.util.ArrayList;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.ListIterator;
import java.io.File;

import es.uca.xmleye.util.ConstructorOrdenes;

public class Editor {
	private static final ResourceBundle errRes;

	static {
		errRes = ResourceBundle.getBundle("es.uca.xmleye.l10n.ErrorMessages",
				Locale.getDefault());
	}

	public static void lanzarEditor(File fichero, String ordenEdicion)
			throws ExcepcionEdicion {
		ArrayList<String> arrOrden = ConstructorOrdenes.prepararOrden(
				ordenEdicion,
				new String[] { ConstantesAplicacion.CLAVE_FUENTE },
				new String[] { fichero.getAbsolutePath() });

		StringBuffer sOrden = new StringBuffer();
		for (ListIterator<String> it = arrOrden.listIterator(); it.hasNext();) {
			sOrden.append(it.next() + " ");
		}

		try {
			// Ejecutamos el editor y nos olvidamos de él
			ProcessBuilder procBuilder = new ProcessBuilder(arrOrden);
			procBuilder.start();
		} catch (Exception ex) {
			throw new ExcepcionEdicion(String.format(errRes
					.getString("err_editor_exec"), sOrden, ex
					.getLocalizedMessage()), ex);
		}
	}
}
